"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _path = require("path");

var DIR_NAME = 'plugin-model';
var MODEL_NAME = 'initialState';
var RELATIVE_MODEL = "".concat(DIR_NAME, "/models/").concat(MODEL_NAME);
var RELATIVE_MODEL_PATH = "".concat(RELATIVE_MODEL, ".ts");

var _default = function _default(api) {
  var paths = api.paths,
      findJS = api.findJS; // 注册 getInitialState 方法

  api.addRuntimePluginKey('getInitialState');
  api.onGenerateFiles(function () {
    var entryFile = findJS((0, _path.join)(paths.absSrcPath, 'app'));

    if (entryFile) {
      var relEntryFile = (0, _path.relative)(paths.cwd, entryFile);
      api.writeTmpFile(RELATIVE_MODEL_PATH, "import { useState, useEffect } from 'react';\nimport { Models } from 'umi';\nimport * as app from '@/app';\n\nexport type InitState = Models<'@@initialState'>;\nasync function getInitialState() {\n  if (!app.getInitialState) {\n    throw new Error('getInitialState is not defined in ".concat(relEntryFile, "');\n  }\n  return await app.getInitialState();\n}\n\ntype ThenArg<T> = T extends Promise<infer U> ? U : T\n\nexport default () => {\n  const [loading, setLoading] = useState(false);\n  const [data, setData] = useState<ThenArg<ReturnType<typeof getInitialState>> | undefined>(undefined);\n\n  const refresh = async() => {\n    setLoading(true);\n    const asyncFunc = () => new Promise<ReturnType<typeof getInitialState>>(res => res(getInitialState()));\n    const ret = await asyncFunc();\n    setData(ret);\n    setLoading(false);\n  };\n\n  useEffect(()=>{\n    refresh();\n  }, []);\n\n  return {\n    initialState: data,\n    refresh,\n    loading,\n  }\n}\n"));
    } else {
      api.writeTmpFile(RELATIVE_MODEL_PATH, "import React from 'react';\n\nexport default () => {\n  console.error('[@umijs/plugin-initial-state]: \u68C0\u6D4B\u5230 @umijs/plugin-initial-state \u63D2\u4EF6\u5DF2\u7ECF\u5F00\u542F\uFF0C\u4F46\u662F\u672A\u5728 app.ts/js \u4E2D\u5B9A\u4E49 getInitialState \u65B9\u6CD5\u3002');\n  return {};\n}\n");
    }
  });
  api.addUmiExports([{
    specifiers: ['InitState'],
    source: (0, _path.join)(api.paths.absTmpDirPath, RELATIVE_MODEL)
  }]);
  api.register('addExtraModels', function () {
    return [{
      absPath: (0, _path.join)(paths.absTmpDirPath, RELATIVE_MODEL_PATH),
      namespace: '@@initialState'
    }];
  });
};

exports.default = _default;